currentWeapon = 0
maxWeapon = 3
shootDelay = 0
bullets0 = { }
bullets1 = { }
bullets2 = { }
bullets3 = { }
shootEffect = { }
bDest = { }
gun = {
	x = 300,
	y = 200,
	width = 16,
	height = 16
}

function player.shoot()
	if currentWeapon == 0 then
		table.insert(bullets0, {
			x = player.x + player.direction * gun.width,
			y = player.y,
			width = 16,
			height = 16,
			direction = player.direction,
			xSpeed = 500,
			ySpeed = 0,
			counter = 0,
			image = love.graphics.newImage("img/bullet0.png")
		})
		
		table.insert(shootEffect, {
		x = player.x + player.direction * (gun.width + 5),
		y = player.y,
		width = 16,
		height = 16,
		counter = 0,
		image = love.graphics.newImage("img/shootEffect.png")
		})
		love.audio.play(gunsound)
	end
	
	if currentWeapon == 2 then
		table.insert(bullets2, {
			x = player.x + player.direction * gun.width,
			y = player.y,
			width = 16,
			height = 16,
			direction = player.direction,
			xSpeed = player.direction * 500,
			ySpeed = -200,
			counter = 0,
			maxYSpeed = 350,
			image = love.graphics.newImage("img/bullet2.png")
		})
		
		table.insert(shootEffect, {
		x = player.x + player.direction * (gun.width + 5),
		y = player.y,
		width = 16,
		height = 16,
		counter = 0,
		image = love.graphics.newImage("img/shootEffect.png")
		})
		love.audio.play(gunsound)
	end
	
	if currentWeapon == 3 and shootDelay <= 0 then
		table.insert(bullets3, {
			x = player.x + player.direction * gun.width,
			y = player.y,
			width = 16,
			height = 16,
			direction = player.direction,
			xSpeed = 450,
			ySpeed = math.random(-75, 75),
			counter = 0,
			image = love.graphics.newImage("img/bullet3.png")
		})
		table.insert(bullets3, {
			x = player.x + player.direction * gun.width,
			y = player.y,
			width = 16,
			height = 16,
			direction = player.direction,
			xSpeed = 450,
			ySpeed = math.random(-75, 75),
			counter = 0,
			image = love.graphics.newImage("img/bullet3.png")
		})
		table.insert(bullets3, {
			x = player.x + player.direction * gun.width,
			y = player.y,
			width = 16,
			height = 16,
			direction = player.direction,
			xSpeed = 450,
			ySpeed = math.random(-75, 75),
			counter = 0,
			image = love.graphics.newImage("img/bullet3.png")
		})
		table.insert(bullets3, {
			x = player.x + player.direction * gun.width,
			y = player.y,
			width = 16,
			height = 16,
			direction = player.direction,
			xSpeed = 450,
			ySpeed = math.random(-75, 75),
			counter = 0,
			image = love.graphics.newImage("img/bullet3.png")
		})
		table.insert(bullets3, {
			x = player.x + player.direction * gun.width,
			y = player.y,
			width = 16,
			height = 16,
			direction = player.direction,
			xSpeed = 450,
			ySpeed = math.random(-75, 75),
			counter = 0,
			image = love.graphics.newImage("img/bullet3.png")
		})
		table.insert(bullets3, {
			x = player.x + player.direction * gun.width,
			y = player.y,
			width = 16,
			height = 16,
			direction = player.direction,
			xSpeed = 450,
			ySpeed = math.random(-75, 75),
			counter = 0,
			image = love.graphics.newImage("img/bullet3.png")
		})
		shootDelay = 10
		
		table.insert(shootEffect, {
		x = player.x + player.direction * (gun.width + 5),
		y = player.y,
		width = 16,
		height = 16,
		counter = 0,
		image = love.graphics.newImage("img/shootEffect.png")
		})
		love.audio.play(gunsound)
	end
end

function player.holdShoot(dt)
	if shootDelay <= 0 then
		if currentWeapon == 1 then
			table.insert(bullets1, {
				x = player.x + player.direction * gun.width,
				y = player.y,
				width = 16,
				height = 16,
				direction = player.direction,
				xSpeed = 500,
				ySpeed = math.random(-20, 20),
				counter = 0,
				image = love.graphics.newImage("img/bullet1.png")
			})
			love.audio.play(gunsound)
			shootDelay = 1.3
	
			table.insert(shootEffect, {
			x = player.x + player.direction * (gun.width + 5),
			y = player.y,
			width = 16,
			height = 16,
			counter = 0,
			image = love.graphics.newImage("img/shootEffect.png")
			})
		end
	end
end

function gun.load()
	gun0Sprites = SpriteAnimation:new("img/gun0.png", 16, 16, 1, 1)
	gun0Sprites:load(120)
	
	gun1Sprites = SpriteAnimation:new("img/gun1.png", 16, 16, 1, 1)
	gun1Sprites:load(120)
	
	gun2Sprites = SpriteAnimation:new("img/gun2.png", 16, 16, 1, 1)
	gun2Sprites:load(120)
	
	gun3Sprites = SpriteAnimation:new("img/gun3.png", 16, 16, 1, 1)
	gun3Sprites:load(120)
end

function gun.keypressed(key)
	if key == "return" then
		currentWeapon = currentWeapon + 1
		shootDelay = 0
	end
end
	
function bullets0.update(dt)
	local i, o
	for i, o in ipairs(bullets0) do
		o.counter = o.counter + 10 * dt

		o.x = o.x + (o.direction * o.xSpeed) * dt
		o.y = o.y + o.ySpeed * dt
		
		if o.counter > 5 or maskedPixel(o.x, o.y, "img/map.png") then
			table.remove(bullets0, i)
			table.insert(bDest, {
		x = o.x,
		y = o.y,
		width = 16,
		height = 16,
		counter = 0,
		image = love.graphics.newImage("img/bDest.png")
	})
		end
	end
end

function bullets1.update(dt)	
	for i, o in ipairs(bullets1) do
		o.counter = o.counter + 10 * dt
		
		o.x = o.x + (o.direction * o.xSpeed) * dt
		o.y = o.y + o.ySpeed * dt
	
		if o.counter > 7 or maskedPixel(o.x, o.y, "img/map.png") then
			table.remove(bullets1, i)
			table.insert(bDest, {
		x = o.x,
		y = o.y,
		width = 16,
		height = 16,
		counter = 0,
		image = love.graphics.newImage("img/bDest.png")
	})
		end
	end
end

function bullets2.update(dt)	
	for i, o in ipairs(bullets2) do
		o.counter = o.counter + 10 * dt
		
		if maskedPixel(o.x + o.xSpeed * dt, o.y) == true then
			o.xSpeed = -1 * o.xSpeed
		end
		if maskedPixel(o.x, o.y + o.ySpeed * dt) == true then
			o.ySpeed = -1 * o.ySpeed
		elseif o.ySpeed < o.maxYSpeed then
			o.ySpeed = o.ySpeed + (1000 * dt)
		end
		
		o.x = o.x + o.xSpeed * dt
		o.y = o.y + o.ySpeed * dt
	
		if o.counter > 15 then
			table.remove(bullets2, i)
			table.insert(bDest, {
		x = o.x,
		y = o.y,
		width = 16,
		height = 16,
		counter = 0,
		image = love.graphics.newImage("img/bDest.png")
	})
		end
	end
end

function bullets3.update(dt)	
	for i, o in ipairs(bullets3) do
		o.counter = o.counter + 10 * dt
		
		o.x = o.x + (o.direction * o.xSpeed) * dt
		o.y = o.y + o.ySpeed * dt
	
		if o.counter > 4 or maskedPixel(o.x + o.xSpeed * dt, o.y, "img/map.png") then
			table.remove(bullets3, i)
			table.insert(bDest, {
		x = o.x,
		y = o.y,
		width = 16,
		height = 16,
		counter = 0,
		image = love.graphics.newImage("img/bDest.png")
	})
		end
	end
end

function shootEffect.update(dt)
	local i, o
	for i, o in ipairs(shootEffect) do
		o.x = player.x + player.direction * (gun.width + 10)
		o.counter = o.counter + 10 * dt
	
		if o.counter > 0.5 then
			table.remove(shootEffect, i)
		end
	end
end

function bDest.update(dt)
	local i, o
	for i, o in ipairs(bDest) do
		o.counter = o.counter + 10 * dt
	
		if o.counter > 0.5 then
			table.remove(bDest, i)
		end
	end
end

function gun.update(dt)
	gun.x = player.x + player.direction * 16
	gun.y = player.y + 4
	
	if currentWeapon > maxWeapon then
		currentWeapon = 0
	end
	
	if shootDelay > 0 then
		shootDelay = shootDelay - 10 * dt
	end
end
 
function bullets0.draw()
	--draw bullets
	local i, o
	for i, o in ipairs(bullets0) do
		love.graphics.draw(o.image, o.x - o.width / 2, o.y - o.height / 2)
	end
end

function bullets1.draw()
	--draw bullets
	local i, o
	for i, o in ipairs(bullets1) do
		love.graphics.draw(o.image, o.x - o.width / 2, o.y - o.height / 2)
	end
end

function bullets2.draw()
	--draw bullets
	local i, o
	for i, o in ipairs(bullets2) do
		love.graphics.draw(o.image, o.x - o.width / 2, o.y - o.height / 2)
	end
end

function bullets3.draw()
	--draw bullets
	local i, o
	for i, o in ipairs(bullets3) do
		love.graphics.draw(o.image, o.x - o.width / 2, o.y - o.height / 2)
	end
end

function shootEffect.draw()
	local i, o
	for i, o in ipairs(shootEffect) do
		love.graphics.draw(o.image, o.x - o.width / 2, o.y - o.height / 2)
	end
end

function bDest.draw()
	local i, o
	for i, o in ipairs(bDest) do
		love.graphics.draw(o.image, o.x - o.width / 2, o.y - o.height / 2)
	end
end

function gun.draw()
	if currentWeapon == 0 then
		gun0Sprites:draw(gun.x - gun.width / 2, gun.y - gun.height / 2)
	end
	
	if currentWeapon == 1 then
		gun1Sprites:draw(gun.x - gun.width / 2, gun.y - gun.height / 2)
	end
	
	if currentWeapon == 2 then
		gun2Sprites:draw(gun.x - gun.width / 2, gun.y - gun.height / 2)
	end
	
	if currentWeapon == 3 then
		gun3Sprites:draw(gun.x - gun.width / 2, gun.y - gun.height / 2)
	end
end