player = {
	x = 300,
	y = 200,
	width = 32,
	height = 32,
	xSpeed = 0,
	ySpeed = 0,
	maxMoveSpeed = 175,
	maxFallSpeed = 400,
	direction = 1,
	onGround = false
}

function player.load()
	--player animation
	playerSprites = SpriteAnimation:new("img/player.png", 32, 32, 4, 4)
	playerSprites:load(120)
	
	gunsound = love.audio.newSource("snd/shoot.ogg", "static")
	gunsound:setVolume(0.5)
end

function player.update(dt)
	playerSprites:update(dt)
	if maskedHLine(player.x - 11, player.y + 16 + player.ySpeed * dt, 22, "img/map.png") == false then
		if player.ySpeed < player.maxFallSpeed then
			player.ySpeed = player.ySpeed + (1000 * dt)
		end
		player.onGround = false
	else
		player.ySpeed = 0
		player.onGround = true
	end
	player.x = player.x + (dt * player.xSpeed)
	player.y = player.y + (dt * player.ySpeed)
end

function player.draw()
	playerSprites:draw(player.x - player.width / 2, player.y - player.height / 2)
end

function player.moveLeft(dt)
	player.direction = -1
	playerSprites:flip(true, false)
		gun0Sprites:flip(true, false)
		gun1Sprites:flip(true, false)
		gun2Sprites:flip(true, false)
		gun3Sprites:flip(true, false)
	playerSprites:switch(2, 4, 120)
	if maskedVLine(player.x + (player.direction * 8) + (player.xSpeed * dt), player.y + 11, 4, "img/map.png") == true then
		player.y = player.y - 5
	end
	if maskedVLine(player.x + (player.direction * 12) + (player.xSpeed * dt), player.y - 14, 24, "img/map.png") == true then
		player.xSpeed = 0
	else
		if player.xSpeed > -1 * player.maxMoveSpeed then
			player.xSpeed = player.xSpeed - (750 * dt)
		end
	end
end

function player.moveRight(dt)
	player.direction = 1
	playerSprites:flip(false, false)
		gun0Sprites:flip(false, false)
		gun1Sprites:flip(false, false)
		gun2Sprites:flip(false, false)
		gun3Sprites:flip(false, false)
	playerSprites:switch(2, 4, 120)
	if maskedVLine(player.x + (player.direction * 8) + (player.xSpeed * dt), player.y + 11, 4, "img/map.png") == true then
		player.y = player.y - 4
	end
	if maskedVLine(player.x + (player.direction * 12) + (player.xSpeed * dt), player.y - 14, 24, "img/map.png") == true then
		player.xSpeed = 0
	else
		if player.xSpeed < player.maxMoveSpeed then
			player.xSpeed = player.xSpeed + (750 * dt)
		end
	end
end

function player.jump()
	if player.onGround == true then
		player.ySpeed = -500
	end
end

function player.jumpEnd()
	if player.ySpeed < 0 then
		player.ySpeed = player.ySpeed / 2
	end
end

function player.stop()
	player.xSpeed = 0
	playerSprites:switch(1, 4, 200)
end

function player.getState()
	local state
	if player.xSpeed ~= 0 then
		state = "walk"
	end
	if player.ySpeed < 0 then
		state = "jump"
	end
	if player.ySpeed > 0 then
		state = "fall"
	end
	return state
end